using Indotalent.Infrastructure.Database;
using MediatR;
using Microsoft.EntityFrameworkCore;

namespace Indotalent.Features.Thirdparty.CustomerGroup.Cqrs;

public class GetCustomerGroupListResponse
{
    public string? Id { get; set; }
    public string? Name { get; set; }
    public string? Description { get; set; }
    public DateTimeOffset? CreatedAt { get; set; }
    public string? CreatedBy { get; set; }
    public DateTimeOffset? UpdatedAt { get; set; }
    public string? UpdatedBy { get; set; }
}

public record GetCustomerGroupListQuery() : IRequest<List<GetCustomerGroupListResponse>>;

public class GetCustomerGroupListHandler : IRequestHandler<GetCustomerGroupListQuery, List<GetCustomerGroupListResponse>>
{
    private readonly AppDbContext _context;

    public GetCustomerGroupListHandler(AppDbContext context) => _context = context;

    public async Task<List<GetCustomerGroupListResponse>> Handle(GetCustomerGroupListQuery request, CancellationToken cancellationToken)
    {
        return await _context.CustomerGroup
            .AsNoTracking()
            .OrderBy(x => x.Name)
            .Select(x => new GetCustomerGroupListResponse
            {
                Id = x.Id,
                Name = x.Name,
                Description = x.Description,
                CreatedAt = x.CreatedAt,
                CreatedBy = x.CreatedBy,
                UpdatedAt = x.UpdatedAt,
                UpdatedBy = x.UpdatedBy,
            })
            .ToListAsync(cancellationToken);
    }
}